<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>


<div id="app">
    <form @submit.prevent="sendMessage">
        <textarea v-model="message" cols="30" rows="10"></textarea>
        <button type="submit">Send Message</button>
    </form>

    <hr>

    <h1>Messages</h1>

    <ul>
        <li v-for="message in list_messages">
            ({{ message.like }}) <button @click="likeMessage(message.key)" >like</button>

            <span contenteditable="true" @blur="updateMessage($event, message.key)">
                {{ message.message }}
            </span>
            <small><i>({{ message.username }})</i></small>
            <button @click="deleteMessage(message.key)">X</button>
        </li>
    </ul>

    <hr>
    <h4>History</h4>
    <ul>
        <li v-for="history in list_history">
            <b>{{ history.username }}</b> - ({{ history.action }})
        </li>
    </ul>
</div>


<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://www.gstatic.com/firebasejs/5.5.0/firebase.js"></script>
<script>

    // Initialize Firebase
    var config = {
        apiKey: "AIzaSyDiPN0kFTU6iMkFOux1W0zxu-MorsEg2Wg",
        authDomain: "taiga-35025.firebaseapp.com",
        databaseURL: "https://taiga-35025.firebaseio.com",
        projectId: "taiga-35025",
        storageBucket: "taiga-35025.appspot.com",
        messagingSenderId: "1006381674874"
    };
    firebase.initializeApp(config);

    let db = firebase.database();


    new Vue({
        el: '#app',
        created() {
            db.ref('/chat')
                .on('value', snapshot => this.loadMessages(snapshot.val()));

            const chat = db.ref('chat');


            chat.on('child_added', data => {
                this.list_history.push({
                    username: this.username,
                    action: 'Added new chat ' + data.key,
                })
            });

            // child change
            /*chat.on('child_change', (d) => {
                this.list_history.push({
                    username: this.username,
                    action: 'Change chat' + d.key,
                })
            });

            // child change
            chat.on('child_removed', (e) => {
                this.list_history.push({
                    username: this.username,
                    action: 'Delete chat' + e.key,
                })
            });*/



        },
        data: {
            message: null,
            like: 0,
            username: 'JoseFlorez',
            list_messages: [],
            list_history: [],
        },
        methods: {
            loadMessages(data) {
                this.list_messages = [];
                for (let key in data) {
                    this.list_messages.push({
                        message: data[key].message,
                        username: data[key].username,
                        like: data[key].like,
                        key: key,
                    });
                }
                this.list_messages.reverse();

            },
            sendMessage() {
                db.ref('chat')
                    .push({
                        message: this.message,
                        username: this.username,
                        like: this.like,
                    }).then((data) => {
                    this.message = '';
                });
            },
            updateMessage(message, key) {
                db.ref('/chat/' + key).update({
                    message: message.target.innerHTML,
                });
            },
            deleteMessage(key) {
                if(confirm('¿Estas seguro?'))
                    db.ref('/chat/' + key).remove()
            },
            likeMessage(key) {
                db.ref('chat').child(key).child('like')
                    .transaction(function (likes) {
                        return likes + 1
                    }, function (error, commited, snapshot) {
                        if(error) {
                            console.error(error)
                        } else if(commited) {
                            console.warn(commited)
                        } else {
                            console.info('Hecho!');
                            console.log(snapshot.val())
                        }
                    })
            }
        }
    });


    // save reference of data
    /*db.ref('/profile/JoseFlorez').set({
        username: 'Jose Florez',
        password: '1094JRFo',
        email: 'rojosefo132@gmail.com'
    }).then(() => console.info('Datos añadidos'))*/

    // push data elements
    /*document.getElementById('form-chat').onsubmit = function (e) {
        e.preventDefault();

        let message = document.getElementById('message')

        db.ref('chat').push({
            username: 'Jose Florez',
            message: message.value,
        }).then(() => {
            console.log('Message send');
            message.value = '';
        })
    }*/


</script>

</body>
</html>